# Product

The `kroger_product` data source is designed to retrieve Kroger product pages.

## Request samples

In the sample below, we make a request to retrieve the product page for product ID `0021006550000`, specify the delivery location using ZIP code `65401`, set the fulfillment type to `delivery`, and assign the store ID to `1100002`.

{% tabs %}
{% tab title="cURL" %}

```bash
curl 'https://realtime.oxylabs.io/v1/queries' \
--user 'USERNAME:PASSWORD' \
-H 'Content-Type: application/json' \
-d '{
        "source": "kroger_product",
        "product_id": "0021006550000",
        "delivery_zip": "65401",
        "fulfillment_type": "pickup",
        "store_id": "01100002"
    }'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint

# Structure payload.
payload = {
    "source": "kroger_product",
    "product_id": "0021006550000",
    "delivery_zip": "65401",
    "fulfillment_type": "pickup",
    "store_id": "01100002",
}

# Get response.
response = requests.request(
    "POST",
    "https://realtime.oxylabs.io/v1/queries",
    auth=("USERNAME", "PASSWORD"),
    json=payload,
)

# Print prettified response to stdout.
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "kroger_product",
    product_id: "0021006550000",
    delivery_zip: "65401",
    fulfillment_type: "pickup",
    store_id: "01100002",
};

const options = {
    hostname: "realtime.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("Error:", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="HTTP" %}

```http
https://realtime.oxylabs.io/v1/queries?source=kroger_product&product_id=0021006550000&delivery_zip=65401&fulfillment_type=pickup&store_id=01100002&access_token=12345abcde
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    'source' => 'kroger_product',
    'product_id' => '0021006550000',
    'delivery_zip' => '65401',
    'fulfillment_type' => 'pickup',
    'store_id' => '01100002'
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://realtime.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");

$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);
```

{% endtab %}

{% tab title="Golang" %}

```go
package main

import (
	"bytes"
	"encoding/json"
	"fmt"
	"io/ioutil"
	"net/http"
)

func main() {
	const Username = "USERNAME"
	const Password = "PASSWORD"

	payload := map[string]interface{}{
		"source":          "kroger_product",
		"product_id":      "0021006550000",
		"delivery_zip":    "65401",
		"fulfillment_type": "pickup",
		"store_id":        "01100002",
	}

	jsonValue, _ := json.Marshal(payload)

	client := &http.Client{}
	request, _ := http.NewRequest("POST",
		"https://realtime.oxylabs.io/v1/queries",
		bytes.NewBuffer(jsonValue),
	)

	request.SetBasicAuth(Username, Password)
	request.Header.Set("Content-Type", "application/json")
	response, err := client.Do(request)
	if err != nil {
		fmt.Println("Error:", err)
		return
	}
	defer response.Body.Close()

	responseText, _ := ioutil.ReadAll(response.Body)
	fmt.Println(string(responseText))
}
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new
            {
                source = "kroger_product",
                product_id = "0021006550000",
                delivery_zip = "65401",
                fulfillment_type = "pickup",
                store_id = "01100002"
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://realtime.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.Encoding.UTF8.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONObject;

import java.util.concurrent.TimeUnit;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "kroger_product");
        jsonObject.put("product_id", "0021006550000");
        jsonObject.put("delivery_zip", "65401");
        jsonObject.put("fulfillment_type", "pickup");
        jsonObject.put("store_id", "01100002");

        Authenticator authenticator = (route, response) -> {
            String credential = Credentials.basic(USERNAME, PASSWORD);

            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .readTimeout(180, TimeUnit.SECONDS)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://realtime.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("Error: " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "kroger_product",
    "product_id": "0021006550000",
    "delivery_zip": "65401",
    "fulfillment_type": "pickup",
    "store_id": "01100002"
}
```

{% endtab %}
{% endtabs %}

We use synchronous [**Realtime**](broken://pages/N4bxieBs231VuAgJ2qC0) integration method in our examples. If you would like to use [**Proxy Endpoint**](broken://pages/hBGdZ6SZ2ONUOM0VIp5t) or asynchronous [**Push-Pull**](broken://pages/DijMC0XcEbNczNgRaHIV) integration, refer to the [**integration methods**](broken://pages/PMUQIFSmnxA40vdpqgqd) section.

## Request parameter values

### Generic

Basic setup and customization options for scraping Kroger product pages.

<table><thead><tr><th width="222">Parameter</th><th width="319.3333333333333">Description</th><th>Default Value</th></tr></thead><tbody><tr><td><mark style="background-color:green;"><strong>source</strong></mark></td><td>Sets the scraper.</td><td><code>kroger_product</code></td></tr><tr><td><mark style="background-color:green;"><strong>product_id</strong></mark></td><td>13-symbol product ID.</td><td>-</td></tr><tr><td><code>render</code></td><td>Enables JavaScript rendering when set to <code>html</code>. <a href="/pages/7sSik87DtvlBOq67ENnO"><strong>More info</strong></a><strong>.</strong></td><td>-</td></tr><tr><td><code>callback_url</code></td><td>URL to your callback endpoint. <a href="/pages/DijMC0XcEbNczNgRaHIV#callback"><strong>More info</strong></a>.</td><td>-</td></tr><tr><td><code>user_agent_type</code></td><td>Device type and browser. The full list can be found <a href="/pages/rrKXR4LNzotP94phU1YL"><strong>here</strong></a>.</td><td><code>desktop</code></td></tr></tbody></table>

&#x20;    \- mandatory parameter

### Localization

Customize results based on store locations, delivery areas, and preferred fulfillment methods.

<table><thead><tr><th width="210">Parameter</th><th width="172.33333333333331">Description</th><th width="153">Default Value</th><th>Dependencies</th></tr></thead><tbody><tr><td><code>store_id</code></td><td>Specify a store. See the available values <a href="https://files.gitbook.com/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FzrXw45naRpCZ0Ku9AjY1%2Fuploads%2FAsihGe7hi5yfauUl2JIQ%2Fkroger_stores.csv?alt=media&#x26;token=40fcd869-1845-47c5-bf76-96e74cabf685"><strong>here</strong></a>. The ID must start with '0'.</td><td>-</td><td>Required when <code>fulfillment_type</code> is set to <code>pickup</code> or <code>in_store</code>.</td></tr><tr><td><code>delivery_zip</code></td><td>Specify delivery location ZIP code.</td><td>-</td><td>Required when <code>fulfillment_type</code> is set to <code>delivery</code>.</td></tr><tr><td><code>fulfillment_type</code></td><td>Specify order fulfillment method. Available values: <code>pickup</code>, <code>delivery</code>, <code>in_store</code>.</td><td><code>pickup</code> (if only <code>store_id</code> is provided)</td><td>Requires <code>store_id</code> for <code>pickup</code> and <code>in_store</code>, or <code>delivery_zip</code> for <code>delivery</code>.</td></tr></tbody></table>

**Dependecies explained:**

* `pickup` and `in_store` values use the `store_id` parameter to determine the correct store.
* `delivery` uses the `delivery_zip` parameter to specify the delivery location.
* If only `store_id` is provided, and `fulfillment_type` is not specified, the default type is `pickup`.

{% hint style="warning" %}
If the `fulfillment_type` and `store_id`/`delivery_zip` combination is invalid (unsupported by Kroger), the scraped page will return with a 404 status.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developers.oxylabs.io/api-targets/e-commerce/kroger/product.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
